简单枚举UVa725-division (abcde / fghij = n)

2023-12-19 05:32

本文主要是介绍简单枚举UVa725-division (abcde / fghij = n),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

题目位置:https://uva.onlinejudge.org/index.php?option=com_onlinejudge&Itemid=8&page=show_problem&problem=666

Write a program that finds and displays all pairs of 5-digit numbers that between them use the digits 0
through 9 once each, such that the first number divided by the second is equal to an integer N, where
2 ≤ N ≤ 79. That is,
abcde
fghij = N
where each letter represents a different digit. The first digit of one of the numerals is allowed to be
zero.
Input
Each line of the input file consists of a valid integer N. An input of zero is to terminate the program.
Output
Your program have to display ALL qualifying pairs of numerals, sorted by increasing numerator (and,
of course, denominator).
Your output should be in the following general form:
xxxxx / xxxxx = N
xxxxx / xxxxx = N
.
.
In case there are no pairs of numerals satisfying the condition, you must write ‘There are no
solutions for N.’. Separate the output for two different values of N by a blank line.
Sample Input
61
62
0
Sample Output
There are no solutions for 61.
79546 / 01283 = 62
94736 / 01528 = 62



开始以为这道题可以暴力枚举,全排列,判断每种情况,结果可想而知,超时。代码也附在下面,像填空题啥的可以用…

看了书之后才发现可以简化很多。具体解释看代码

特别注意,结尾没有空行~!!!

这里是

sprintf(buf,"%05d%05d",abcde,fghij)

先转化成字符串,然后排序,再依次判断对应位置是否为i

同时很巧妙的是提前判断一下长度超过10就肯定不满足,而之后的数也会越来越大,所以直接break;



另外判断是否为0~9,如果是数字的话,还可以按照

1+2+3+4+5+…+9=45

1*2*3*4*5*…*9=362880

来判断


//巧妙的借助fghij可以由ancde获得,减少了循环次数。不用把每种情况列举出来
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cstring>
using namespace std;int main(){int n,kase=0;int fghij,abcde;char buf[20];while(scanf("%d",&n)!=EOF&&n){if(kase++) printf("\n");<span style="white-space:pre">		</span>//开头输出\nint num = 0;for(fghij = 1234;fghij<49384;fghij++){      //!!!注意截至条件,98765/2=49384bool ok=1;abcde=fghij*n;sprintf(buf,"%05d%05d",abcde,fghij);if(strlen(buf)>10) break;                //书上是break,如果是有临界条件,continue也可以 sort(buf,buf+10);<span style="white-space:pre">			</span>//排序以后对0~9是否出现进行判断for(int i = 0; i <=9; i++){if(buf[i]!=i+'0'){ok=0;break;}}if(ok){printf("%05d / %05d = %d\n",abcde,fghij,n);num++;}}if(num==0) printf("There are no solutions for %d.\n",n);}return 0;
}



最后也附上超级暴力的枚举,全排序可以借鉴

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
using namespace std;int main(){int n,ok=0,a[10];for(int i=0;i<=9;i++) a[i]=i;while(scanf("%d",&n)!=EOF&&n){ok=0;do{int x=a[9]*10000+a[8]*1000+a[7]*100+a[6]*10+a[5];int y=a[0]*10000+a[1]*1000+a[2]*100+a[3]*10+a[4];if(y*n==x){printf("%d/%d = %d\n",x,y,n);ok=1;}}while(next_permutation(a,a+10));if(ok==0) printf("There are no solutions for %d.\n",n);}return 0;
}










这篇关于简单枚举UVa725-division (abcde / fghij = n)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/511032

相关文章

csu 1446 Problem J Modified LCS (扩展欧几里得算法的简单应用)

这是一道扩展欧几里得算法的简单应用题,这题是在湖南多校训练赛中队友ac的一道题,在比赛之后请教了队友,然后自己把它a掉 这也是自己独自做扩展欧几里得算法的题目 题意:把题意转变下就变成了:求d1*x - d2*y = f2 - f1的解,很明显用exgcd来解 下面介绍一下exgcd的一些知识点:求ax + by = c的解 一、首先求ax + by = gcd(a,b)的解 这个

hdu2289(简单二分)

虽说是简单二分,但是我还是wa死了  题意:已知圆台的体积,求高度 首先要知道圆台体积怎么求:设上下底的半径分别为r1,r2,高为h,V = PI*(r1*r1+r1*r2+r2*r2)*h/3 然后以h进行二分 代码如下: #include<iostream>#include<algorithm>#include<cstring>#include<stack>#includ

usaco 1.3 Prime Cryptarithm(简单哈希表暴搜剪枝)

思路: 1. 用一个 hash[ ] 数组存放输入的数字,令 hash[ tmp ]=1 。 2. 一个自定义函数 check( ) ,检查各位是否为输入的数字。 3. 暴搜。第一行数从 100到999,第二行数从 10到99。 4. 剪枝。 代码: /*ID: who jayLANG: C++TASK: crypt1*/#include<stdio.h>bool h

uva 10387 Billiard(简单几何)

题意是一个球从矩形的中点出发,告诉你小球与矩形两条边的碰撞次数与小球回到原点的时间,求小球出发时的角度和小球的速度。 简单的几何问题,小球每与竖边碰撞一次,向右扩展一个相同的矩形;每与横边碰撞一次,向上扩展一个相同的矩形。 可以发现,扩展矩形的路径和在当前矩形中的每一段路径相同,当小球回到出发点时,一条直线的路径刚好经过最后一个扩展矩形的中心点。 最后扩展的路径和横边竖边恰好组成一个直

hdu 2489 (dfs枚举 + prim)

题意: 对于一棵顶点和边都有权值的树,使用下面的等式来计算Ratio 给定一个n 个顶点的完全图及它所有顶点和边的权值,找到一个该图含有m 个顶点的子图,并且让这个子图的Ratio 值在所有m 个顶点的树中最小。 解析: 因为数据量不大,先用dfs枚举搭配出m个子节点,算出点和,然后套个prim算出边和,每次比较大小即可。 dfs没有写好,A的老泪纵横。 错在把index在d

poj 1113 凸包+简单几何计算

题意: 给N个平面上的点,现在要在离点外L米处建城墙,使得城墙把所有点都包含进去且城墙的长度最短。 解析: 韬哥出的某次训练赛上A出的第一道计算几何,算是大水题吧。 用convexhull算法把凸包求出来,然后加加减减就A了。 计算见下图: 好久没玩画图了啊好开心。 代码: #include <iostream>#include <cstdio>#inclu

uva 10130 简单背包

题意: 背包和 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstring>#include <cmath>#include <stack>#include <vector>#include <queue>#include <map>

hdu 6198 dfs枚举找规律+矩阵乘法

number number number Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Problem Description We define a sequence  F : ⋅   F0=0,F1=1 ; ⋅   Fn=Fn

【Rust练习】12.枚举

练习题来自:https://practice-zh.course.rs/compound-types/enum.html 1 // 修复错误enum Number {Zero,One,Two,}enum Number1 {Zero = 0,One,Two,}// C语言风格的枚举定义enum Number2 {Zero = 0.0,One = 1.0,Two = 2.0,}fn m

JAVA用最简单的方法来构建一个高可用的服务端,提升系统可用性

一、什么是提升系统的高可用性 JAVA服务端,顾名思义就是23体验网为用户提供服务的。停工时间,就是不能向用户提供服务的时间。高可用,就是系统具有高度可用性,尽量减少停工时间。如何用最简单的方法来搭建一个高效率可用的服务端JAVA呢? 停工的原因一般有: 服务器故障。例如服务器宕机,服务器网络出现问题,机房或者机架出现问题等;访问量急剧上升,导致服务器压力过大导致访问量急剧上升的原因;时间和